<template>
  <div id="wrap">
    <coscine-page-header
      :coscineImage="coscineImage"
      :coscineImageBlack="coscineImageBlack"
      :locale="this.$root.$i18n.locale"
      @changeLocale="changeLocale"
    />
    <div id="CreateProject" class="container-fluid app-content">
      <b-row>
        <div class="col-sm-2"></div>
        <div class="col-sm-8">
          <div>
            <h5>{{ $t('headline') }}</h5>
          </div>
          <div>{{ $t(displayMessage) }}</div>
        </div>
        <div class="col-sm-2"></div>
      </b-row>
    </div>
    <coscine-loading-spinner
      :isWaitingForResponse="isWaitingForResponse"
      :textAfter="$t('loadingSpinnerTokenConfirmation')"
    />
  </div>
</template>

<script lang="ts">
import { BRow } from 'bootstrap-vue';
import Vue from 'vue';
Vue.component('b-row', BRow);

import { GuidUtil } from '@coscine/app-util';
import { ContactChangeApi } from '@coscine/api-connection';
import {
  CoscinePageHeader,
  CoscineLoadingSpinner,
} from '@coscine/component-library';
import '@coscine/component-library/dist/index.css';

import coscineImagePath from './assets/logo-rwth.svg';
import linkWhitePath from './assets/link_white.svg';
import mailGreyPath from './assets/mail_grey.svg';
import phoneGreyPath from './assets/phone_grey.svg';
import faxGreyPath from './assets/fax_grey.svg';


let scriptPath = '';
let imageEnabled = false;
if (document.currentScript !== undefined) {
  scriptPath = (document.currentScript as any).src as string;
  imageEnabled = true;
}
const scriptUrl = scriptPath === '' ? '/' : scriptPath.substring(0, scriptPath.indexOf('app.js'));
const rootUrl = scriptPath.indexOf('/js') !== -1 ? scriptUrl.replace('/js', '') : scriptUrl;

export default Vue.extend({
  name: 'tokenconfirmation',
  components: {
    CoscinePageHeader,
    CoscineLoadingSpinner,
  },
  computed: {
    cssProps() {
      return {
        '--linkWhite': 'url(' + rootUrl + linkWhitePath + ') 1px 9px no-repeat',
        '--mailGrey': 'url(' + rootUrl + mailGreyPath + ') 0px 6px no-repeat',
        '--phoneGrey': 'url(' + rootUrl + phoneGreyPath + ') 0px 6px no-repeat',
        '--faxGrey': 'url(' + rootUrl + faxGreyPath + ') 0px 6px no-repeat',
      };
    },
  },
  data() {
    return {
      coscineImage: rootUrl + coscineImagePath,
      isWaitingForResponse: false,
      displayMessage: 'validating',
    };
  },
  methods: {
    changeLocale() {
      if (this.$root.$i18n.locale === 'en') {
        this.$root.$i18n.locale = 'de';
      } else {
        this.$root.$i18n.locale = 'en';
      }
    },
    validateToken() {
      const token = this.getToken();
      if (token !== null) {
        this.isWaitingForResponse = true;
        ContactChangeApi.confirm(
          token,
          (response: any) => {
            this.displayMessage = 'validatedTokenSuccess';
            this.isWaitingForResponse = false;
          },
          (error: any) => {
            this.displayMessage = 'validatedTokenFailure';
            this.isWaitingForResponse = false;
          }
        );
      } else {
        this.displayMessage = 'invalidToken';
      }
    },
    getToken() {
      const urlParams = new URLSearchParams(window.location.search);
      if (urlParams.has('token')) {
        const token = urlParams.get('token');
        if (GuidUtil.isValidGuid(token)) {
          return token;
        }
      }
      return null;
    },
  },
  created() {
    this.displayMessage = 'validating';
    this.validateToken();
  },
});
</script>

<style scoped>
#wrap {
  width: 100%;
}
.list-group-item-action {
  background: var(--linkWhite) !important;
}
#mail.list-group-item-action {
  background: var(--mailGrey) !important;
}
#phone.list-group-item {
  background: var(--phoneGrey) !important;
}
#fax.list-group-item {
  background: var(--faxGrey) !important;
}
</style>

<style>
body {
  background-color: white;
}
#edit_form .col-form-label {
  font-weight: 700;
}
</style>
